from simpleGPfun import *
NAREA    = 10               # 染色体の数
Area     = array(2,NAREA)   # 染色体領域
Cross    = 0.2              # 交叉率
Mutation = 0.02             # 突然変異率
Selection=1-(Cross+Mutation)# 選択率
Prob=array(3)               # 遺伝操作選択用累積分布
Prob[0]=Selection;Prob[1]=Prob[0]+Cross;Prob[2]=1
def initArea(cID): #■初期設定
    global Area,NAREA
    src=["2","A","B","C","2","D"]
    delTab=["*","+","/","-","**"]#四則演算のみ対応する
    for i in range(NAREA):
        S=src[0]
        for k in range(1,6):
            ID=int(random.random()*5)
            S+=delTab[ID]+src[k]
        Area[cID][i]=sourceToTree(S,False)
def trueValue(trueTree,VL):#真値（本来は出力例示データ）
    try:V0=execTree(trueTree,VL)# 目標とする真値の計算
    except: V0=0                # 安全のための処理
    return V0
def GPEX(NumG,Debug=False):
    global Area, NAREA
    VL=[["A",1],["B",2], ["C",3],["D",4]]#変数リスト初期値
    cID=0;nID=1-cID
    src1=" 2*D+2*A+C+B"#真値計算式
    trueTree=sourceToTree(src1,False)#真値計算構文木
    initArea(nID); NUM=len(Area[0])#初期化
    Fitness=setFitness(trueValue(trueTree,VL),
                       NAREA, Area[nID], VL)#適応度計算
    if Debug:
        print("\n初期値")
        printVlist(VL)#print("\n変数名リスト",VL)
        for i in range(NAREA):
            print("\n",i,"番目 適応度=%8.4f"% Fitness[i])
            printTree(Area[nID][i])
        printFitness(Fitness)
    for i in range(NumG):
        cID=nID;nID=1-cID #現世代と次世代の格納位置切り替え
        VL=setVL(VL)      #変数値のランダム設定
        Fitness=setFitness(trueValue(trueTree,VL),
                           NAREA, Area[cID], VL)#適応度計算
        if checkFitness(Fitness):initArea(cID)
        CDisp=cumDisp(Fitness)#適応度の累積度数分布
        k=0
        while k<NUM:#出力側が満杯になるまで遺伝子操作
            R=random.random()#乱数による操作選択
            S1=selectUnit(CDisp)
            if R<Prob[0]:#選択
                Area[nID][k]=Area[cID][S1]
                k+=1
            elif R<Prob[1]:
                if k==NUM-1:#最後なら選択とみなす
                    Area[nID][k]=Area[cID][S1]
                    k+=1
                else:#交差(組み換え)
                    S2=selectUnit(CDisp)
                    while S1==S2: S2=selectUnit(CDisp)
                    DNODE1=randomProc(Area[cID][S1])#入替え部分木1
                    DNODE2=randomProc(Area[cID][S2])#入替え部分木2
                    Area[nID][k]=crossTree(DNODE1[0],#部分木1置換
                                           Area[cID][S1],DNODE2[1])
                    k+=1
                    Area[nID][k]=crossTree(DNODE2[0],#部分木2置換
                                           Area[cID][S2],DNODE1[1])
                    k+=1
            else:#突然変異
                Area[nID][k]=mutationProc(Area[cID][S1],VL)
                k+=1
    cID=nID
    #print("\n---------結果---------------\n")
    Fitness=setFitness(trueValue(trueTree,VL),
                       NAREA, Area[cID], VL)
    return [cID,Fitness,VL]
def GP(LOOP, NumG,Debug=False):#■遺伝的プログラミング処理
    global Area, NAREA
    for i in range(LOOP):
        R=GPEX(NumG,Debug);cID=R[0];Fitness=R[1];VL=R[2]
        MX=max(Fitness)
        if MX>0.9999:break
    print("\n---------結果---------------\n")
    src1=" 2*D+2*A+C+B"#真値計算式
    print("\n",src1)
    trueTree=sourceToTree(src1,False)#真値計算構文木
    print("\n真値構文木")
    printTree(trueTree)
    print()
    flag=True;mxTree=[]
    for i in range(NAREA):
        if Fitness[i]==MX:
            if flag:
                mxTree.append([i,Area[cID][i]])
                flag=False
            else:
                kflag=True #同じ構文木があったら無視する
                for k in range(len(mxTree)):
                    if mxTree[k][1]==Area[cID][i]:
                        kflag=False;break
                if kflag:mxTree.append([i,Area[cID][i]])
    for i in range(len(mxTree)):
        print("\n番号",mxTree[i][0])
        printTree(mxTree[i][1])
    printFitness(Fitness)
    printVlist(VL)
GP(100,50,Debug=True)

